﻿//Credit to HighVolts for SetLootPoi & CheckLootFrame
using Styx;
using Styx.Common;
using Styx.Common.Helpers;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.CommonBot.Frames;
using Styx.CommonBot.POI;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Seeker.Classes
{
    public class Common
    {
        private static readonly WaitTimer LootTimer = WaitTimer.FiveSeconds;
        public static int lumbermillskill = StyxWoW.Me.GetSkill(1945).CurrentValue;
        public static string name { get { return Seeker.TheSeeker.name; } }
        static public bool GameReady
        {
            get
            {
                return (StyxWoW.Me != null && StyxWoW.IsInGame && StyxWoW.Me.IsAlive && !StyxWoW.Me.IsGhost);
            }
        }
        static public bool IsValid(WoWUnit unit)
        {
            return unit != null && unit.IsValid && !Blacklist.Contains(unit.Guid, BlacklistFlags.All);
        }
        static public bool IsValid(WoWGameObject unit)
        {
            return unit != null && unit.IsValid && !Blacklist.Contains(unit.Guid, BlacklistFlags.All);
        }
        public static void SetLootPoi(WoWObject lootObj)
        {
            if (BotPoi.Current.Type != PoiType.None || lootObj == null || !lootObj.IsValid)
                return;

            if (lootObj is WoWGameObject)
            {
                BotPoi.Current = new BotPoi(lootObj, PoiType.Harvest);
            }
            else
            {
                var unit = lootObj as WoWUnit;
                if (unit != null)
                {
                    if (unit.CanLoot)
                        BotPoi.Current = new BotPoi(lootObj, PoiType.Loot);
                    else if (unit.CanSkin)
                        BotPoi.Current = new BotPoi(lootObj, PoiType.Skin);
                }
            }
        }
        private static async Task<bool> CheckLootFrame()
        {
            if (!LootTimer.IsFinished)
            {
                // loot everything.
                if (TheSeeker.Instance.LootFrameIsOpen)
                {
                    for (int i = 0; i < LootFrame.Instance.LootItems; i++)
                    {
                        LootSlotInfo lootInfo = LootFrame.Instance.LootInfo(i);                        
                    }
                    LootFrame.Instance.LootAll();
                    LootTimer.Stop();
                    await CommonCoroutines.SleepForLagDuration();
                }
                return true;
            }
            return false;
        }
        static public void Dismount(string reason)
        {
            if (Settings.General.Instance.AdvancedLogging) Logging.Write(name + ":Forced Dismount: reason:" + reason);
            Lua.DoString("Dismount()");
        }
    }
}
