﻿using Buddy.Coroutines;
using Styx;
using Styx.Common;
using Styx.Common.Helpers;
using Styx.CommonBot;
using Styx.CommonBot.POI;
using Styx.Pathing;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Seeker.Classes
{
    public class Looting : Common
    {
        private static WaitTimer Interacttimer = new WaitTimer(TimeSpan.FromSeconds(2));
        public static void LootCheck()
        {
            if (BotPoi.Current.Type == PoiType.None)
            {
                //Loot killed creatures
                if (IsValid(LootableUnit) && (Styx.Helpers.CharacterSettings.Instance.LootMobs ||
                    (LootableUnit.Classification == WoWUnitClassificationType.Rare ||
                    LootableUnit.Classification == WoWUnitClassificationType.RareElite ||
                    LootableUnit.Classification == WoWUnitClassificationType.Elite)))
                {                    
                    SetLootPoi(LootableUnit);
                    return;
                }                
            }
        }
        public static async Task DoLoot(WoWUnit Supplies)
        {
            using (new PerformanceLogger(name + ": GatherSupplies"))
            {
                if (Supplies != null && Supplies.IsValid)
                {
                    WoWGuid TargetGuid = Supplies.Guid;
                    if (await Loot(Supplies))
                    {
                        //I have to assume that if we made it this far that looting is done, Remove it.
                        if (Settings.General.Instance.AdvancedLogging) Logging.Write(name + ":" + Supplies.SafeName + " appears to be looted, removing from our list");
                        Blacklist.Add(TargetGuid, BlacklistFlags.Loot, TimeSpan.FromMinutes(5));
                        BotPoi.Clear();
                    }
                }
            }
        }
        public static async Task<bool> Loot(WoWUnit Lootable)
        {
            using (new PerformanceTimer(name + ": Collect"))
            {
                if (Lootable == null)
                    return true;
                if (Lootable != null)
                {
                    if (!Blacklist.Contains(Lootable.Guid, BlacklistFlags.Loot) && await Movement.MoveToTargetRoutine(Lootable))
                    {
                        if (Lootable.Location.Distance(StyxWoW.Me.Location) <= Lootable.InteractRange && !StyxWoW.Me.IsMoving && Interacttimer.IsFinished)
                        {                            
                            Interacttimer.Reset();
                            Lootable.Interact();                            
                            return !Lootable.Lootable;
                        }
                    }
                }
                return false;
            }
        }
        private static WoWUnit LootableUnit
        {
            get
            {
                return ObjectManager.GetObjectsOfType<WoWUnit>().Where(o => IsValid(o) &&
                    o.IsDead && o.KilledByMe && o.CanLoot &&
                    Navigator.CanNavigateFully(StyxWoW.Me.Location, o.Location)).FirstOrDefault();
            }
        }
    }
}
