﻿using Buddy.Coroutines;
using Styx;
using Styx.Common;
using Styx.CommonBot.POI;
using Styx.Pathing;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
using Seeker;

namespace Seeker.Classes
{
    class Movement : Common
    {
        //public static string LastLog;
        public static async Task<bool> MoveToTargetRoutine(WoWUnit Rare)
        {
            MoveResult result;
            //If already in combot lets let the CR handle movement
            if (StyxWoW.Me.IsActuallyInCombat)
                return true;
            if (StyxWoW.Me.Location.Distance(Rare.Location) <= Rare.InteractRange)
                return true;
            Styx.CommonBot.TreeRoot.StatusText = "Moving to " + Rare.SafeName;
            if (Flightor.MountHelper.CanMount && Flightor.CanFly)
            {
                Flightor.MoveTo(Rare.Location);
                return true;
            }
            else
            {
                result = await Styx.CommonBot.Coroutines.CommonCoroutines.MoveTo(Rare.Location, Rare.SafeName);
                return result != MoveResult.Failed && result != MoveResult.PathGenerationFailed;
            }


        }
        public static async Task<bool> MoveToTargetRoutine(WoWGameObject Lootable)
        {
            MoveResult result;
            //If already in combot lets let the CR handle movement
            if (StyxWoW.Me.IsActuallyInCombat)
                return true;
            if (StyxWoW.Me.Location.Distance(Lootable.Location) <= Lootable.InteractRange)
                return true;
            Styx.CommonBot.TreeRoot.StatusText = "Moving to " + Lootable.SafeName;
            if (Flightor.MountHelper.CanMount && Flightor.CanFly)
            {
                Flightor.MoveTo(Lootable.Location);
                return true;
            }
            else
            {
                result = await Styx.CommonBot.Coroutines.CommonCoroutines.MoveTo(Lootable.Location, Lootable.SafeName);
                return result != MoveResult.Failed && result != MoveResult.PathGenerationFailed;
            }

        }
        public static async Task<bool> FollowPath()
        {
            MoveResult result;
            var moveto = TheSeeker.Instance.Profile.CurrentPoint;

            if (moveto == WoWPoint.Zero)
            {
                Logging.Write("No Profile, Waiting");
                return false;
            }

            float precision = 3;

            Styx.CommonBot.TreeRoot.StatusText = "Patrolling ";

            if (StyxWoW.Me.Location.Distance(moveto) <= precision)
                TheSeeker.Instance.Profile.CycleToNextPoint();

            if (Flightor.MountHelper.CanMount && Flightor.CanFly)
            {
                Flightor.MoveTo(moveto);
            }
            else
            {
                result = await Styx.CommonBot.Coroutines.CommonCoroutines.MoveTo(moveto);
                return Navigator.AtLocation(moveto) || (result != MoveResult.Failed && result != MoveResult.PathGenerationFailed);
            }
            return true;
        }
    }
}
