﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Styx.Helpers;
using System.IO;
using Styx.Common;
using System.ComponentModel;

using DefaultValue = Styx.Helpers.DefaultValueAttribute;

namespace Seeker.Settings
{
    public class General : Styx.Helpers.Settings
    {
        public static General Instance = new General();
        public General()
            : base(Path.Combine(Utilities.AssemblyDirectory, string.Format(@"Settings/TheSeeker/General.xml")))
        {
        }
        [Setting, DefaultValue(false), Category("Debugging")]
        public bool PerformaceLogging { get; set; }

        [Setting, DefaultValue(true), Category("Debugging")]
        public bool AdvancedLogging { get; set; }

        [Setting, DefaultValue(new int[]{}), Category("General")]
        public int[] CreatureEntries { get; set; }

        [Setting, DefaultValue(false), Category("General")]
        public bool KillRaresonSight { get; set; }

        [Setting, DefaultValue(true), Category("General")]
        public bool OpenLootables { get; set; }

        [Setting, DefaultValue(true), Category("General")]
        public bool HarvestTimber { get; set; }

        [Setting, DefaultValue(true), Category("General")]
        public bool HarvestHerbs { get; set; }

        [Setting, DefaultValue(true), Category("General")]
        public bool HarvestMinerals { get; set; }

        [Setting, DefaultValue(true), Category("General")]
        public bool GarrisonSupplies { get; set; }

        [Setting, DefaultValue(""), Category("General")]
        public string LastLoadedProfile { get; set; }

        [Setting, DefaultValue(""), Category("Special Circumstances")]
        public string SlowFallSpell { get; set; }

        [Setting, DefaultValue(""), Category("Special Circumstances")]
        public string SlowFallItem { get; set; }
    }
}

